/*******************************************************************************

    SINALIZADOR DE R (C/ EFEITOS SONORO E LUMINOSO)



    C/ PIC12F675


    AUTOR: CLAUDIO LARIOS

    DATA:21/12/2020
    
    DEVE SER CONECTADO AOS FIOS DAS LAMPADAS DE INDICAO DE R. 
    PRODUZ SOM DE UMA SIRENE E PISCA GRUPOS DE LEDS EM FLASH PARA
    ALERTAR PESSOAS QUE O VECULO EST EM MANOBRA DE MARCHA R.

    P/ CCS C COMPILER V3.200

    USO DIDTICO
    ESTE ARQUIVO  PARTE INTEGRANTE DO BLOG LARIOS.TECNOLOGIA.WS

*******************************************************************************/
#include <12F675.h>
#device adc=10
#use delay(clock=4000000)
#fuses NOWDT,INTRC_IO, NOCPD, NOPROTECT, NOMCLR, PUT, BROWNOUT

//bytes
#byte  TRISIO = 0x85
#byte  GPIO   = 0x05
#byte  CMCOM  = 0X19
#byte  ANSEL  = 0X9F
#byte  TMR0   = 0X01
#byte  T1CON  = 0X10
#byte  TMR1L   = 0X0E
#byte  TMR1H   = 0X0F
#byte  WPU     = 0X95
#byte  PIE1    = 0X8C
#byte  INTCON  = 0X0B
#byte  OPTION_REG   = 0X81
// bits
#bit TMR1IF = 0xC.0

//pinos do pic

#bit piezo = 0x05.2  //pino 5 sada de som
#bit gled1 = 0x05.5  //pino 2 sada para grupo de leds 1
#bit gled2 = 0x05.4  //pino 3 sada para grupo de leds 2


//variveis globais

unsigned int8 cnt, auxa, auxb, auxd, auxc, ger=0, proc=0;


/*******************************************************************************
                          SUBROTINAS
*******************************************************************************/

void inverte_saida(){
  for(auxa=0;auxa<cnt;auxa++){ delay_us(6);}
  piezo= piezo ^ 1;
}




void som_sirene1(){
 //   for(auxd=0; auxd<10;auxd++){//numero de execues
    cnt=40;//frequencia
     for(auxc=0; auxc<50;auxc++){//passo

       for(auxb=0; auxb<15;auxb++){//permanncia
         inverte_saida();
       }
       if(cnt>128){
         cnt = 0;
       }
       else{
         cnt = cnt + 1;
       }
     }
   // }
 }

 void som_sirene2(){//estilo = rpida
  unsigned int8 auxj=0;
  //  for(auxd=0; auxd<100;auxd++){//numero de execues
    cnt=40;//frequencia
     for(auxc=0; auxc<50;auxc++){//passo

       for(auxb=0; auxb<3;auxb++){//permanncia
         inverte_saida();
       }
       if(cnt>64)auxj=1;
       if(cnt==1)auxj=0;
       if(auxj==1){
         cnt = cnt - 1;
       }
       else{
         cnt = cnt + 1;
       }
     }
   // }
 }

 void som_sirene3(){
    //sirene legal (alerta)
 //   for(auxd=0; auxd<50;auxd++){//numero de execues
    cnt=100;//frequencia
     for(auxc=0; auxc<10;auxc++){//passo

       for(auxb=0; auxb<40;auxb++){//permanncia
         inverte_saida();
       }
       cnt = cnt - 2;
     }
  //  }
 }

 void som_sirene4(){
    //sirene alarme rpido 1 (toooouu! tooooouuu! toooouuu!)
  //  for(auxd=0; auxd<30;auxd++){//numero de execues
    cnt=20;//frequencia
     for(auxc=0; auxc<30;auxc++){//passo

       for(auxb=0; auxb<12;auxb++){//permanncia
         inverte_saida();
       }
       if(cnt>128){
         cnt = cnt - 2;
       }
       else{
         cnt = cnt + 2;
       }
     }
   // }
 }


void som_sirene5(){
   //sirene  disparos rpidos (usar junto com outra)
 //   for(auxd=0; auxd<50;auxd++){//numero de execues
    cnt=20;//frequencia
     for(auxc=0; auxc<10;auxc++){//passo

       for(auxb=0; auxb<12;auxb++){//permanncia
         inverte_saida();
       }
       if(cnt>128){
         cnt = cnt - 5;
       }
       else{
         cnt = cnt + 5;
       }
     }
  //  }
}

void som_sirene6(){

   //sirene (iaaauuuuu!  iiiaaauuu!)
  //  for(auxd=0; auxd<10;auxd++){//numero de execues
    cnt=20;//frequencia
     for(auxc=0; auxc<10;auxc++){//passo

       for(auxb=0; auxb<80;auxb++){//permanncia
         inverte_saida();
       }
       if(cnt>128){
         cnt = cnt - 5;
       }
       else{
         cnt = cnt + 5;
       }
     }
  //  }
}

void som_sirene7(){
//sirene tipo policia
  //  for(auxd=0; auxd<30;auxd++){//numero de execues
    cnt=39;//frequencia
     for(auxc=0; auxc<12;auxc++){//passo

       for(auxb=0; auxb<6;auxb++){//permanncia
         inverte_saida();
       }
       cnt = cnt - 5;
     }
  //  }
}

void som_sirene8(){
 //sirene alarme rpido 1
  //  for(auxd=0; auxd<10;auxd++){//numero de execues
    cnt=40;//frequencia
     for(auxc=0; auxc<50;auxc++){//passo

       for(auxb=0; auxb<5;auxb++){//permanncia
         inverte_saida();
       }
       if(cnt>128){
         cnt = cnt - 2;
       }
       else{
         cnt = cnt + 6;
       }
     }
   // }
}

void som_sirene9(){

  //som de arma espacial 1 (tchooo') lento
  //  for(auxd=0; auxd<10;auxd++){//numero de execues
    cnt=40;//frequencia
     for(auxc=0; auxc<50;auxc++){//passo

       for(auxb=0; auxb<9;auxb++){//permanncia
         inverte_saida();
       }
       if(cnt>128){
         cnt = cnt - 2;
       }
       else{
         cnt = cnt + 6;
       }
     }
   // }
}

void som_sirene10(){
//gun space
  //  for(auxd=0; auxd<10;auxd++){//numero de execues
    cnt=39;//frequencia
     for(auxc=0; auxc<18;auxc++){//passo

       for(auxb=0; auxb<9;auxb++){//permanncia
         inverte_saida();
       }
       cnt = cnt - 8;
     }
  //  }
}

void som_sirene11(){
 //space gun 5 rpida (metralhando)
  //  for(auxd=0; auxd<20;auxd++){//numero de execues
    cnt=10;//frequencia
     for(auxc=0; auxc<10;auxc++){//passo

       for(auxb=0; auxb<30;auxb++){//permanncia
         inverte_saida();
       }
       if(cnt>128){
         cnt = cnt - 7;
       }
       else{
         cnt = cnt + 3;
       }
     }
   // }
}
void som_sirene12(){

       //space gun 4 rpida (metralhando)
  //  for(auxd=0; auxd<20;auxd++){//numero de execues
    cnt=20;//frequencia
     for(auxc=0; auxc<30;auxc++){//passo

       for(auxb=0; auxb<6;auxb++){//permanncia
         inverte_saida();
       }
       if(cnt>128){
         cnt = cnt - 2;
       }
       else{
         cnt = cnt + 4;
       }
     }
   // }
}
void som_sirene13(){
//gun space2
   // for(auxd=0; auxd<10;auxd++){//numero de execues
    cnt=44;//frequencia
     for(auxc=0; auxc<18;auxc++){//passo

       for(auxb=0; auxb<9;auxb++){//permanncia
         inverte_saida();
       }
       cnt = cnt - 8;
     }
   // }
}

void som_sirene14(){
  //space gun 3 (tchuuu! tchuuu!)
  //  for(auxd=0; auxd<10;auxd++){//numero de execues
    cnt=20;//frequencia
     for(auxc=0; auxc<30;auxc++){//passo

       for(auxb=0; auxb<12;auxb++){//permanncia
         inverte_saida();
       }
       if(cnt>128){
         cnt = cnt - 2;
       }
       else{
         cnt = cnt + 4;
       }
     }
  //  }
}

void som_sirene15(){
  //extranha (doleto bum doleto bum)
 //   for(auxd=0; auxd<10;auxd++){//numero de execues
    cnt=37;//frequencia
     for(auxc=0; auxc<10;auxc++){//passo

       for(auxb=0; auxb<40;auxb++){//permanncia
         inverte_saida();
       }
       cnt = cnt - 20;
     }
  //  }
}

void som_sirene16(){
 //poim poim
  //  for(auxd=0; auxd<10;auxd++){//numero de execues
    cnt=100;//frequencia
     for(auxc=0; auxc<10;auxc++){//passo

       for(auxb=0; auxb<40;auxb++){//permanncia
         inverte_saida();
       }
       cnt = cnt - 40;
     }
   // }
}
void som_sirene17(){

  //bp
 //   for(auxd=0; auxd<10;auxd++){//numero de execues
    cnt=20;//frequencia
     for(auxc=0; auxc<10;auxc++){//passo

       for(auxb=0; auxb<80;auxb++){//permanncia
         inverte_saida();
       }
       cnt = cnt - 50;
     }
   // }
}

void som_sirene18(){
 //sirene alarme rpido 1
   // for(auxd=0; auxd<10;auxd++){//numero de execues
    cnt=40;//frequencia
     for(auxc=0; auxc<50;auxc++){//passo

       for(auxb=0; auxb<15;auxb++){//permanncia
         inverte_saida();
       }
       if(cnt>128){
         cnt = cnt ^ 0b10000000;
       }
       else{
         cnt = cnt + 1;
       }
     }
  //  }
}

void som_sirene19(){
  // for(auxd=0; auxd<10;auxd++){//numero de execues
     for(auxc=0; auxc<50;auxc++){//passo
       cnt=20;
       for(auxb=0; auxb<15;auxb++){//permanncia
         inverte_saida();
       }
       cnt=15;
       for(auxb=0; auxb<15;auxb++){//permanncia
         inverte_saida();
       }
     }
  //  }
}

void som_sirene20(){//2 tons
  
      cnt=72;
      for(auxc=0; auxc<40;auxc++){//passo
        for(auxb=0; auxb<25;auxb++){//permanncia
           inverte_saida();
        }
      }
      cnt=81;
      for(auxc=0; auxc<40;auxc++){//passo
        for(auxb=0; auxb<25;auxb++){//permanncia
           inverte_saida();
        }
      }
   
}

void som_sirene21(){//campainha telefone 2
  cnt=64;
 
     for(auxc=0; auxc<3;auxc++){//passo
       cnt=91;
       for(auxb=0; auxb<30;auxb++){//permanncia
         inverte_saida();
       }
       cnt=102;
       for(auxb=0; auxb<30;auxb++){//permanncia
         inverte_saida();
       }
     
    
    }
   
     for(auxc=0; auxc<3;auxc++){//passo
       cnt=81;
       for(auxb=0; auxb<30;auxb++){//permanncia
         inverte_saida();
       }
       cnt=91;
       for(auxb=0; auxb<30;auxb++){//permanncia
         inverte_saida();
       }
     }
    
   
}

void som_sirene22(){
 // for(auxe=0;auxe<3;auxe++){//numero de execues
    cnt=100;//frequencia

    for(auxd=0; auxd<4;auxd++){//passo 2

     for(auxc=0; auxc<10;auxc++){//passo

       for(auxb=0; auxb<40;auxb++){//permanncia
         inverte_saida();
       }
       cnt = cnt - 40;
     }
    }
    cnt=112;
 // }
}

void som_sirene23(){
// for(auxe=0; auxe<5;auxe++){//numero de execues
    cnt=70;//frequencia
  //poim poim
    for(auxd=0; auxd<5;auxd++){//numero de execues

     for(auxc=0; auxc<15;auxc++){//passo

       for(auxb=0; auxb<40;auxb++){//permanncia
         inverte_saida();
       }
       cnt = cnt - 50;
     }
    }
    cnt=79;
 //}
}

void som_sirene24(){
// for(auxd=0; auxd<3;auxd++){//numero de execues
    cnt=10;//frequencia
     for(auxc=0; auxc<15;auxc++){//passo

       for(auxb=0; auxb<70;auxb++){//permanncia
         inverte_saida();
       }
       cnt = cnt - 12;
     }
  //  }
}


/*******************************************************************************
              Rotina de Interrupo do Timer 1
*******************************************************************************/
#int_timer1
void ISR_TIMER1(){
   TMR1H=0Xd8;//carga para 10 ms
   TMR1L=0Xef;
   ger++;//incrementa a cada 10 ms
   
    if(proc<3){   //gera 3 flash no grupo de leds 1
     switch (ger){
      case 1: gled1=1; break;//liga grupo de leds 1
      case 4: gled1=0; break;//desliga aps 30 ms
      case 11: proc++; ger=0; break;   
   
     }//switch (ger){
    }//if(proc<3){  
   
   
   
      
    if(proc==3){
      if(ger==31){//intervalo de 300ms com leds apagados
        proc++;
        ger=0;
     }
    }
    
    if(proc>3 && proc<7){   //gera 3 flash no grupo de leds 2
     switch (ger){
      case 1: gled2=1; break;//liga grupo de leds 2
      case 4: gled2=0; break;//desliga aps 30 ms
      case 11: proc++; ger=0; break;      
     }//switch (ger){
    }//if(proc>2 && proc<6){   
   
    if(proc==7){
      if(ger==31){//intervalo de 300ms com leds apagados
        proc++;
        ger=0;
     }
    }
    
    
    if(proc>7 && proc<11){   //gera 3 flash no grupo de leds 1 e 2
     switch (ger){
      case 1: gled1=1; gled2=1;break;//liga grupo de leds 1
      case 4: gled1=0; gled2=0;break;//desliga aps 30 ms
      case 11: proc++; ger=0; break;      
     }//switch (ger){
    }//if(proc>2 && proc<6){   
   
    if(proc==11){
      if(ger==31){//intervalo de 300ms com leds apagados
        proc=0;//finaliza ciclo 
        ger=0;
     }
    }
    
   
   
}

/*******************************************************************************
                        ROTINA MAIN
*******************************************************************************/

void main() {

   CMCOM = 7;//desliga comparadores
   GPIO = 0;//zera tudo
   TRISIO = 0b001011;//ajusta entradas e sadas
   ANSEL = 0;// desabilita ports p/ conversores ADC
   T1CON = 0x01;//liga timer1  prescaller/1
   TMR1IF=0;
   TMR1H=0Xd8;//carga para 10 ms
   TMR1L=0Xef;
   WPU= 0X3F;
   OPTION_REG=0;
   PIE1=1;//liga interrupo do timer 1
   INTCON= 0B11000000;//GIE=1 /PEIE=1 //liga interrupo


   /*******************************************************************************
           LOOP PRINCIPAL DE REPETIO
*******************************************************************************/


   for(;;){
       
   //escolha um som (som_sireneXX(); sendo XX = 1 a 24);
   
       //  som_sirene14();
       //  som_sirene11();
       //  som_sirene3();
           som_sirene18();
       
           
           
   }//for()
}//main()


/*
































   }//for(;;)

}//void main()


*/
